#ifndef TODOlist_h_
#define TODOlist_h_

#include "liste_type.h"

/*!
************************************************
* \brief ajouter un element dans une liste d'entiers triee
* par recursion. 
* NB: le plus petit entier est en tete de liste. 
* \param pliste pointeur sur une liste
* \param val un entier a ajouter à la liste triee
* \warning On passe un pointeur sur une liste (donc un pointeur
*   sur un pointeur sur un element)
* \post La liste est modifiee: un element est insere avec 
* la valeur val
* \return retourne 0 si il n'y a pas d'erreur, 1 sinon
* \see ajouterListe
**************************************************/
int ajouterListeTriee (LISTE *pliste, int val); 

/*!
************************************************
* \brief fusion de deux listes triees par recursion. 
* \param pliste1 pointeur sur la premiere liste
* \param pliste2 pointeur sur la seconde liste
* \post la premiere liste contient tous les elements tries, 
* tandis que la seconde est vide
**************************************************/
void fusion (LISTE *pliste1, LISTE *pliste2); 

#endif
