#include <stdio.h>

#include "liste.h"

//TODO implementer le corps des fonctions suivantes
//dans un fichier TODOliste.c
#include "TODOliste.h"

/*!
* \brief Teste si la liste l d'entiers 
* est triee par ordre croissant
* \param l une liste d'entiers
* \return 1 si l est triee, 0 sinon
*/    
int testTri(LISTE l)
{
  int estTrie; //1 si la liste est triee, 0 sinon
  ELEMLISTE *elem; //element de liste 
  int val, plusPetiteVal; //valeurs (entieres)

  //init
  estTrie = 1; 
  if (l != NULL)
    plusPetiteVal = l->elem;

  //pour toutes les paires d'entiers consecutifs
  while ( (l != NULL)&&(estTrie) )
    {
      elem = l; //element de tete de liste
      val = elem->elem; //sa valeur
      l = elem->suivant; //mise a jour de la liste
      //fprintf(stderr, "comparaison ( %d > %d ) \n", plusPetiteVal, val); 
      if (plusPetiteVal > val) //comparaison
	  estTrie = 0;  
      plusPetiteVal = val; 
    }

  //conclusion
  if (estTrie)
    fprintf(stderr, " => est trie \n"); 
  else 
    fprintf(stderr, " => n'est pas trie \n"); 
  return estTrie ? 1 : 0;
}

/*!
 * \brief Fonction qui teste les fonctions 
 * de base concernant les listes triees
 * \return 1 si ok, 0 sinon
 * \see testTri
*/
int testFonctionsTri()
{
  LISTE liste, liste1, liste2; 
  int estOk; //1 si ok, 0 sinon

  fprintf(stdout,"/********** test sur les listes triees ******************\n");

  fprintf(stdout,"/********** ajout en tete de liste  *********************\n");
  liste = initListe();
  ajouterListe(&liste, 5);
  fprintf(stdout,"apres ajout de 5\n");
  ajouterListe(&liste, 3);
  fprintf(stdout,"apres ajout de 3\n");
  ajouterListe(&liste, 2);
  fprintf(stdout,"apres ajout de 2\n");
  ajouterListe(&liste, 1);
  fprintf(stdout,"apres ajout de 1\n");
  ajouterListe(&liste, 1);
  fprintf(stdout,"apres ajout de 1\n");
  afficherListe(liste);

  //test
  estOk = (tailleListe(liste) == 5) && testTri(liste); 
  viderListe(&liste); 
  afficherListe(liste);

  if (estOk)
    {

      liste = initListe(); 
      ajouterListe(&liste, 3);
      fprintf(stdout,"apres ajout de 3\n");
      ajouterListe(&liste, 5);
      fprintf(stdout,"apres ajout de 5\n");
      afficherListe(liste);

      //test
      estOk = estOk && (tailleListe(liste) == 2) && (!testTri(liste)); 
      viderListe(&liste); 
      afficherListe(liste);
    }

  if (estOk)
    {
      fprintf(stdout,"/********** insertion dans une liste triee  **************\n"); 
      ajouterListeTriee(&liste, 1);
      fprintf(stdout,"apres ajout de 1\n");
      ajouterListeTriee(&liste, 5);
      fprintf(stdout,"apres ajout de 5\n");
      ajouterListeTriee(&liste, 1);
      fprintf(stdout,"apres ajout de 1\n");
      ajouterListeTriee(&liste, 3);
      fprintf(stdout,"apres ajout de 3\n");
      ajouterListeTriee(&liste, 2);
      fprintf(stdout,"apres ajout de 2\n");
      afficherListe(liste);

      //test
      estOk = estOk && (tailleListe(liste) == 5) && testTri(liste); 
      viderListe(&liste); 
      afficherListe(liste);
    }

  if (estOk)
    {
      fprintf(stdout,"/********** fusion de listes triees ********************\n"); 
      //remplissage listes
      liste1 = initListe();
      ajouterListeTriee(&liste1, 1);
      ajouterListeTriee(&liste1, 2);
      ajouterListeTriee(&liste1, 3);
      ajouterListeTriee(&liste1, 4);
      ajouterListeTriee(&liste1, 5);
      afficherListe(liste1);
      liste2 = initListe();
      ajouterListeTriee(&liste2, 2);
      ajouterListeTriee(&liste2, 4);
      ajouterListeTriee(&liste2, 6);
      ajouterListeTriee(&liste2, 8);
      ajouterListeTriee(&liste2, 10);
      afficherListe(liste2);
      //fusion
      fusion(&liste1, &liste2); 
      afficherListe(liste1);
      //test
      estOk = estOk 
	&& (tailleListe(liste1) == 10) 
	&& (tailleListe(liste2) == 0) 
	&& testTri(liste1); 
      viderListe(&liste1); 
      viderListe(&liste2); 
    }

  if (estOk)
    {
      fprintf(stdout,"/********** fusion de listes triees ********************\n"); 
      //remplissage listes
      liste1 = initListe();
      ajouterListeTriee(&liste1, 1);
      ajouterListeTriee(&liste1, 2);
      ajouterListeTriee(&liste1, 3);
      ajouterListeTriee(&liste1, 4);
      ajouterListeTriee(&liste1, 5);
      afficherListe(liste1);
      liste2 = initListe();
      ajouterListeTriee(&liste2, 6);
      ajouterListeTriee(&liste2, 7);
      ajouterListeTriee(&liste2, 8);
      ajouterListeTriee(&liste2, 9);
      ajouterListeTriee(&liste2, 10);
      afficherListe(liste2);
      //fusion
      fusion(&liste1, &liste2); 
      afficherListe(liste1);
      //test
      estOk = estOk 
	&& (tailleListe(liste1) == 10) 
	&& (tailleListe(liste2) == 0) 
	&& testTri(liste1); 
      viderListe(&liste1); 
      viderListe(&liste2); 
    }

  if (estOk)
    {
      fprintf(stdout,"/********** fusion de listes triees ********************\n"); 
      //remplissage listes
      liste1 = initListe();
      ajouterListeTriee(&liste1, 6);
      ajouterListeTriee(&liste1, 7);
      ajouterListeTriee(&liste1, 8);
      ajouterListeTriee(&liste1, 9);
      ajouterListeTriee(&liste1, 10);
      afficherListe(liste1);
      liste2 = initListe();
      ajouterListeTriee(&liste2, 1);
      ajouterListeTriee(&liste2, 2);
      ajouterListeTriee(&liste2, 3);
      ajouterListeTriee(&liste2, 4);
      ajouterListeTriee(&liste2, 5);
      afficherListe(liste2);
      //fusion
      fusion(&liste1, &liste2); 
      afficherListe(liste1);
      //test
      estOk = estOk 
	&& (tailleListe(liste1) == 10) 
	&& (tailleListe(liste2) == 0)
	&& testTri(liste1); 
      viderListe(&liste1); 
      viderListe(&liste2); 
    }

  if (estOk)
    {
      fprintf(stdout,"/********** fusion de listes triees ********************\n"); 
      //remplissage listes
      liste1 = initListe();
      ajouterListeTriee(&liste1, 6);
      ajouterListeTriee(&liste1, 7);
      ajouterListeTriee(&liste1, 8);
      ajouterListeTriee(&liste1, 9);
      ajouterListeTriee(&liste1, 10);
      afficherListe(liste1);
      liste2 = initListe();
      afficherListe(liste2);
      //fusion
      fusion(&liste1, &liste2); 
      afficherListe(liste1);
      //test
      estOk = estOk 
	&& (tailleListe(liste1) == 5) 
	&& (tailleListe(liste2) == 0)
	&& testTri(liste1); 
      viderListe(&liste1); 
      viderListe(&liste2); 
    }

  if (estOk)
    {
      fprintf(stdout,"/********** fusion de listes triees ********************\n"); 
      //remplissage listes
      liste1 = initListe();
      afficherListe(liste1);
      liste2 = initListe();
      ajouterListeTriee(&liste2, 1);
      ajouterListeTriee(&liste2, 2);
      ajouterListeTriee(&liste2, 3);
      ajouterListeTriee(&liste2, 4);
      ajouterListeTriee(&liste2, 5);
      afficherListe(liste2);
      //fusion
      fusion(&liste1, &liste2); 
      afficherListe(liste1);
      //test
      estOk = estOk 
	&& (tailleListe(liste1) == 5) 
	&& (tailleListe(liste2) == 0)
	&& testTri(liste1); 
      viderListe(&liste1); 
      viderListe(&liste2); 
    }

  return estOk; 
}

/*!
 * \brief Fonction qui teste les fonctions 
 * de base concernant les listes
 * \return 1 s'il n'y a pas d'erreurs, 0 sinon. 
*/
int testFonctionsDeBase()
{
  LISTE liste; 
  int val; 
  int estOk; //1 si ok, 0 sinon
  estOk = 1; 

  fprintf(stdout,"/********** test rapide des fonctions de base *************\n");

  liste = initListe(); //0 elt
  if (tailleListe(liste) != 0)
    estOk = 0; 

  ajouterListe(&liste, 1); //1 elt

  fprintf(stdout,"apres ajout de 1\n");

  ajouterListe(&liste, 2); //2 elts

  fprintf(stdout,"apres ajout de 2\n");
  afficherListe(liste);

  if (tailleListe(liste) != 2)
    estOk = 0; 

  val = retirerListe(&liste); //1 elt

  fprintf(stdout,"suppression de %d\n",val);
  afficherListe(liste);

  if (tailleListe(liste) != 1)
    estOk = 0; 

  viderListe(&liste); //0 elt

  fprintf(stdout,"apres liberation memoire \n");
  afficherListe(liste);

  if (tailleListe(liste) != 0)
    estOk = 0; 

  return estOk; 
}

/*!
 * \brief Programme qui teste si les fonctions 
 * concernant les listes sont correctes
 * \see testFonctionsDeBase testFonctionsTri
*/
int main(int argc,char **argv)
{

  int estOk; //1 si ok, 0 sinon
  estOk = 1; 

  //tests
  estOk = testFonctionsDeBase()
    && testFonctionsTri(); 

  //conclusion
  if (estOk) 
    fprintf(stdout, "PASSED\n"); 
  else
    fprintf(stdout, "FAILED\n"); 
  return estOk ? 0 : 1;
}

